#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "rpc.h"

int	verbose = 0;

void	usage(void)
{
	fprintf(stderr,"Usage: net_redir -s PORT@HOST -d 3 -- client\n");
}

/* used with net_redir; assumes that descriptor 3 is the network */
int main(int	ac,
	 char	**av)
{
	int			which;
	int			i0, i1, i2;
	double			d0, d1;

	struct srss_state	state;

	int			opt, rv;

	while ((opt = getopt(ac,av,"v")) != EOF) switch (opt) {
	case 'v':	verbose++;		break;
	default:	usage(); exit(0);	break;
	}

	srss_client_init(&state,3);
	do {
		printf("which rpc? ");
		scanf("%d",&which);
	} while ((which < 0 || which > 1) && (puts("bad rpc num"), 1));
	printf("i0: "); scanf("%d",&i0);
	printf("i1: "); scanf("%d",&i1);
	if (which == 0) {
		printf("i2: "); scanf("%d",&i2);
	}
	printf("d0: "); scanf("%lf",&d0);
	printf("d1: "); scanf("%lf",&d1);

	if (verbose) printf("marshalling arglist\n");
	if (which == 0) {
		srss_marshall(&state,"dlfdlfd",i0,d0,i1,d1,i2);
	} else {
		srss_marshall(&state,"dlfdlf",i0,d0,i1,d1);
	}
	if (verbose) printf("performing RPC\n");
	rv = srss_rpc(&state,which);
	printf("RPC reply %d\n",rv);

	if (rv > 0 && srss_unmarshall(&state,"lf",&d0) == 1) {
		printf("reply value: %f\n",d0);
	} else {
		printf("bad reply\n");
	}
	return 0;
}
